import java.util.*;
import java.util.stream.Stream;

public class Sample {
  public static void main(String[] args) {
    List<Integer> numbers = Arrays.asList(1, 2, 3, 5, 4, 6, 7, 8, 9, 10);
    
    Stream<Integer> partial = 
      numbers.stream()
             .filter(Sample::isGT3)
             .filter(Sample::isEven)
             .map(Sample::doubleIt);
             
    System.out.println("No work done yet");
    System.out.println(partial.findFirst());
  }
  
  public static boolean isGT3(int number) {
    System.out.println("isGT3 for " + number);
    return number > 3;
  }
  
  public static boolean isEven(int number) {
    System.out.println("isEven for " + number);
    return number % 2 == 0;
  }
  
  public static int doubleIt(int number) {
    System.out.println("doubleIt for " + number);
    return number * 2;
  }
}
